﻿/******************************************************************************
 * 文件名称: Structs.cs
 * 文件说明: 结构体的封装
 * 当前版本: V1.0
 * 创建日期: 2022-04-12
 *
 * 2020-04-12: 增加 businessDLLInvoke 方法




******************************************************************************/
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedInsuInterface.Variables
{
    //配置信息
    public struct IrisConfigue{
        public string ip;
        public string url;
        public string authorization;
    }

    //接口固定信息
    public struct InterfaceInfo
    {
        public int interfaceDr;
        public string InsuRegionInterfaceDr;
        public string interfaceID;
        public string interfaceName;
        public int hisHospitalDr;
        public int hospitalDr;
        public string hospitalName;
        public string hospitalNO;
        public string centerURL;
        public string cardURL;
        public string ecURL;
        public string areaCode;
        public string dllName;
        public string version;
        public string signatureType;
        public string recivedSystem;
        public string AK;
        public string SK;
        public string dev_no;
        public string dev_safe_info;
        public string cainfo;

    }

    //DLL信息
    public struct DllInfo
    {
        
        public  string className ;
        public  String name ;
        public  String nameSpace ;
    }

    //用户信息
    public struct User
    {
        public string ID;
        public string name;
        public string type;
        public string officeID;
        public string officeName;
        public string deptID;
        public string deptName;
    }

    //患者信息
    public struct Patients
    {
        public int adm_Dr; //HIS就诊ID
        public string mdtrtID; //医保就诊ID
        public string name;
        public string gend;
        public string naty;
        public string age;
        public string brdy;
        public string psn_no;
        public string insuType;
        public string medType;
        public string IDNO;//身份证号码
        public string certNO;
        public string certType;
        public string mdtrtcertNO;
        public string mdtrtcertType;
        public string admDiagCode; //Admission Diagnosis
        public string admDiagName;//诊断名称
        public string discDiagCode; //病种编码
        public string discDiagName;
        public string insuplc_admdvs;//参保地
        public Card card;
        public string settlID;
        public string billID;
        public string recordID;
        public string psn_insu_date;
        public string cvlserv_flag;
        public string balc;
        public string emp_name;
        public string psn_type;
        public string psn_insu_stas;
        public string paus_insu_date;
        public int admType;
        public bool isCommercialInsurance;//是否商业保险
        public string specAttribute;//特殊人员标识属性

    }

    public struct Card
    {
        public string type;
        public string SN;
        public string password;
        public string level;
        public string NO;
        //广州增加
        public string basinfo; //基本信息
        public string chkinfo; //校验信息
    }

    //费用信息
    public struct Fees
    {
        public int adm_Dr;
        public string mdtrtID;
        public string feeDetlSn;
        public string orderNO;
        public string hisCode;
        public string hisName;
        public string insuCode;
        public string insuName;
        public string sumamt;
        public string count;
        public string price;
        public string billDeptCode;
        public string billDeptName;
        public string billDrCode;
        public string billDrName;
        public string acceptDeptCode;
        public string acceptDeptName;
        public string orderDrCode;
        public string orderDrName;
        public string limitUseFlag;
        DateTime occurTime;
        public string insuplc_admdvs;
        
    }

    //结算信息
    public struct Settlements
    {
        
        public int adm_Dr;
        public string mdtrtID;
        public string settlID;
        public string billID;
        public string recordID;
        public string clearingType;
        public string clearingWay;
        public string clearingOrgan;
        DateTime occurTime;
        public int hospitalizationsTimes;
        public int hospitalizationsDays;
        public string hisAdmTime;
        public string hisDischargeTime;
    }

    //当前环境实时信息
    public struct currentEnvironment
    {
        public  string path;
        public string mac;
        public string ip;

        public string signno;
        public string msgid;
        public string URL;
        public JArray jaSession;

        public string MIVer;//医保平台版本 1 老医保平台（成都，南昌） 2.新医保平台 （哈尔滨，广州，云南）

    }
}
